<%-- 
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of the Example Code Package for BASE.
	Available at http://baseplugins.thep.lu.se/
	BASE main site: http://base.thep.lu.se/
	
	This is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.
	
	The software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
--%>
<%@ page 
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.JspContext"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
// Get the JspContext that was created on the main edit page
final JspContext jspContext = (JspContext)request.getAttribute(JspContext.ATTRIBUTE_KEY);

// The current item is found in the context. NOTE! Can be null if a new item
final BasicItem item = (BasicItem)jspContext.getCurrentItem();

// Get the DbControl and SessionControl used to handle the request (do not close!)
final DbControl dc = jspContext.getDbControl();
final SessionControl sc = dc.getSessionControl();
final String ID = sc.getId();

AnyToAny any = null;

// Try to get the currently attached history file
File currentFile = null;
boolean readCurrentFile = true;
if (item != null)
{
	try
	{
		any = AnyToAny.getByName(dc, item, "history-file");
		if (any != null && any.getToType() == Item.FILE)
		{
			currentFile = (File)any.getTo();
		}
	}
	catch (ItemNotFoundException ex)
	{} // There is no file 
	catch (PermissionDeniedException ex)
	{
		// There is a file but the user doesn't have permission to it
		readCurrentFile = false;
	}
}
%>
<base:page type="include">
	<base:head />
	<base:body>
		<script>
		function browseOnClick()
		{
			var frm = document.forms[0];
			var url = getRoot() + '/filemanager/index.jsp?ID=<%=ID%>';
			url += '&cmd=SelectOne&title=Select+history+file';
			url += '&callback=setFileCallback&resetTemporary=1';
			if (frm.history_file_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.history_file_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectFile', 1050, 700);
		}
		function setFileCallback(id, path)
		{
			var frm = document.forms[0];
			var list = frm.history_file_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = path;
			list.selectedIndex = 1;
		}
		</script>
		<table class="fullform input100">
		<tr>
			<th>History file</th>
			<td>
				<base:select 
					id="history_file_id"
					clazz="selectionlist"
					required="false"
					current="<%=currentFile%>"
					denied="<%=!readCurrentFile%>"
					newitem="<%=item == null%>"
					onselect="browseOnClick()"
				/>
			</td>
			<td></td>
		</tr>
		<tr class="dynamic">
			<th>Description</th>
			<td>
				<textarea class="text" rows="6" name="history_description" 
					><%=HTML.encodeTags(any == null ? "" : any.getDescription())%></textarea>
			</td>
			<td style="width: 20px;">
				<base:icon image="zoom.png" 
					onclick="Main.zoom('Description', document.forms[0].name, 'history_description')"
					tooltip="Edit in larger window"
				/>
			</td>
		</tr>
		</table>
	</base:body>
</base:page>

